"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _factory = require("./factory");

var _factory2 = _interopRequireDefault(_factory);

var _axios = require("axios");

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var API = function () {
  function API() {
    (0, _classCallCheck3.default)(this, API);
  }

  (0, _createClass3.default)(API, [{
    key: "pattern",
    value: function pattern() {
      var test = function test() {
        return process.env.ENV == "test";
      };
      var notTest = function notTest() {
        return !test();
      };
      return {
        httpGetRemote: notTest,
        httpGetTest: test,
        httpPostRemote: notTest,
        httpPostTest: test
      };
    }
  }, {
    key: "getVariant",
    value: function getVariant() {
      return [this.getVariantParams, this.httpGet];
    }
  }, {
    key: "getVariantParams",
    value: function getVariantParams(_ref) {
      var name = _ref.name;
      var _ref$state = _ref.state;
      var remote = _ref$state.remote;
      var session_id = _ref$state.session_id;

      return {
        params: { context: "name:" + name, session_id: session_id },
        url: "" + remote.base + remote.test_path,
        responder: function responder(response) {
          var data = response.data.data;
          return { variant: data.name, variant_data: data };
        },
        testResponder: function testResponder() {
          return { variant: "aremote" };
        }
      };
    }
  }, {
    key: "httpGet",
    value: function httpGet() {
      return [this.httpGetRemote, this.httpGetTest];
    }
  }, {
    key: "httpGetRemote",
    value: function httpGetRemote(_ref2) {
      var params = _ref2.params;
      var responder = _ref2.responder;
      var url = _ref2.url;
      var resolve = _ref2.promise.resolve;

      _axios2.default.get(url, { params: params }).then(function (response) {
        return resolve(responder(response));
      });
    }
  }, {
    key: "httpGetTest",
    value: function httpGetTest(_ref3) {
      var testResponder = _ref3.testResponder;
      var resolve = _ref3.promise.resolve;

      resolve(testResponder());
    }
  }, {
    key: "httpPost",
    value: function httpPost() {
      return [this.httpPostRemote, this.httpPostTest];
    }
  }, {
    key: "httpPostRemote",
    value: function httpPostRemote(_ref4) {
      var params = _ref4.params;
      var responder = _ref4.responder;
      var url = _ref4.url;
      var resolve = _ref4.promise.resolve;

      _axios2.default.post(url, params).then(function (response) {
        return resolve(responder(response));
      });
    }
  }, {
    key: "httpPostTest",
    value: function httpPostTest(_ref5) {
      var testResponder = _ref5.testResponder;
      var resolve = _ref5.promise.resolve;

      resolve(testResponder());
    }
  }, {
    key: "postConversion",
    value: function postConversion() {
      return [this.postConversionParams, this.httpPost];
    }
  }, {
    key: "postConversionParams",
    value: function postConversionParams(_ref6) {
      var name = _ref6.name;
      var _ref6$reward = _ref6.reward;
      var reward = _ref6$reward === undefined ? "1.0" : _ref6$reward;
      var variant = _ref6.variant;
      var remote = _ref6.state.remote;

      return {
        params: { arm: variant, context: "name:" + name, reward: reward },
        url: "" + remote.base + remote.convert_path,
        responder: function responder(response) {
          return {};
        },
        testResponder: function testResponder() {
          return {};
        }
      };
    }
  }]);
  return API;
}();

exports.default = (0, _factory2.default)(API);
//# sourceMappingURL=remote.js.map